diff --git a/bfd/cpu-arm.c b/bfd/cpu-arm.c
index 0b7a8c45580d09f010a1062510fd8b1bf3b5cf4f..8d6977aee47fa11514298d43f027523e152dabbc 100644
--- a/bfd/cpu-arm.c
+++ b/bfd/cpu-arm.c
@@ -165,6 +165,7 @@ processors[] =
   { bfd_mach_arm_8R,	  "cortex-r52"	    },
   { bfd_mach_arm_7,	  "cortex-r7"	    },
   { bfd_mach_arm_7,	  "cortex-r8"	    },
+  { bfd_mach_arm_8,	  "cortex-x1"	    },
   { bfd_mach_arm_4T,	  "ep9312"	    },
   { bfd_mach_arm_8,	  "exynos-m1"	    },
   { bfd_mach_arm_4,	  "fa526"	    },
diff --git a/gas/config/tc-arm.c b/gas/config/tc-arm.c
index 455a1401b7fa9c40426933b82b465393c1c25be7..9f8f153ada97c54f177f916a6370a965237561df 100644
--- a/gas/config/tc-arm.c
+++ b/gas/config/tc-arm.c
@@ -31588,6 +31588,9 @@ static const struct arm_cpu_option_table arm_cpus[] =
   ARM_CPU_OPT ("cortex-m0plus",	  "Cortex-M0+",	       ARM_ARCH_V6SM,
 	       ARM_ARCH_NONE,
 	       FPU_NONE),
+  ARM_CPU_OPT ("cortex-x1",   "Cortex-X1",	       ARM_ARCH_V8_2A,
+	       ARM_FEATURE_CORE_HIGH (ARM_EXT2_FP16_INST),
+	       FPU_ARCH_DOTPROD_NEON_VFP_ARMV8),
   ARM_CPU_OPT ("exynos-m1",	  "Samsung Exynos M1", ARM_ARCH_V8A,
 	       ARM_FEATURE_CORE_HIGH (ARM_EXT2_CRC),
 	       FPU_ARCH_CRYPTO_NEON_VFP_ARMV8),
diff --git a/gas/doc/c-arm.texi b/gas/doc/c-arm.texi
index 16c94de675cbfaca076b415753026990f66f4d19..f8ed8bb904e61b08e91d4ba6ed954c6ddb9370cf 100644
--- a/gas/doc/c-arm.texi
+++ b/gas/doc/c-arm.texi
@@ -147,6 +147,7 @@ recognized:
 @code{cortex-m1},
 @code{cortex-m0},
 @code{cortex-m0plus},
+@code{cortex-x1},
 @code{exynos-m1},
 @code{marvell-pj4},
 @code{marvell-whitney},
diff --git a/gas/testsuite/gas/arm/cpu-cortex-x1.d b/gas/testsuite/gas/arm/cpu-cortex-x1.d
new file mode 100644
index 0000000000000000000000000000000000000000..68b869b5c43262bb5d1a3bd85f4b7f593fce46bd
--- /dev/null
+++ b/gas/testsuite/gas/arm/cpu-cortex-x1.d
@@ -0,0 +1,6 @@
+# name: Assemble and dump for cortex-x1 CPU
+# source: nop-asm.s
+# as: -mcpu=cortex-x1
+# objdump: -d -mcortex-x1
+
+#...
